# Параметры запуска из командной строки

**Любой из параметров, кроме VAParams, можно передать в файле VAParams.json.**

| Параметр | Тип | Описание |
|--|--|--|
| VAParams | Строка |Путь к файлу json с основными настройками Vanessa-Automation. Устаревшее значение параметра: "VBParams". Доступные значения файла настроек [можно посмотреть тут](https://github.com/Pr-Mex/vanessa-automation/blob/develop/docs/JsonParams/JsonParamsRU.md)|
| StartFeaturePlayer | Булево | Параметр означает, что нужно запустить тесты на выполнение, согласно параметрам переданным в VAParams.  |
| QuietInstallVanessaExt или ТихаяУстановкаVanessaExt | Булево | Выполняет тихую установку компоненты VanessaExt, без показа модального диалога пользователю. Для работы опции необходима установка толстого клиента платформы и возможность запускать файловые базы. |
| InstallVanessaExtOnFailOfQuietInstall | Булево | Указывает, что если не получилось сделать тихую установку компоненты все равно выполнять её подключение. Это имеет смысл, если Vanessa Automation запускается на компьютере, на котором ранее уже проводилась установка данной версии внешней компоненты VanessaExt, и поэтому не будет вызван модальный диалог, который платформа показывает при первой установке компоненты. |
| QuietInstallVanessaExtAndClose | Булево | Выполняет тоже самое, что и предыдущая опция, но после установки компоненты сеанс 1С буде закрыт. Тесты при этом выполняться не будут. Используется для гарантированной установки внешней компоненты до запуска основного сеанса тестирования. |
| WorkspaceRoot | Строка | Определяет путь к каталогу проекта. По умолчанию каталогом проекта являет каталог, в котором находится основная обработка vanessa-automation.epf |
| ClearStepsCache | Булево |  Очищает кеш шагов при запуске Vanessa-Automation. Параметр может быть полезен, чтобы блокировать загрузку кеша шагов, который мог остаться у данного пользователя в данной базе. |
| DisableUserSettingsLoader | Булево | Отключает работу плагина "Загрузчик пользовательских настроек". Использование параметра уменьшает количество серверных вызовов, если не планируется использовать даный плагин. |
| DisableLoadTestClientsTable | Булево | Отключает загрузку списка клиентов тестирования. Параметр может быть полезен, чтобы блокировать загрузку списка клиентов тестирования, который мог остаться у данного пользователя в данной базе. |
| DisableLoadConfig | Булево |  Отключает загрузку настроек Vanessa-Automation. Параметр может быть полезен, чтобы блокировать загрузку настроек пользователя, которые могли остаться у данного пользователя в данной базе. |
| DisableFeatureLoadOnOpenForm | Булево |  Отключает загрузку фича файла при старте Vanessa-Automation. Аналогично установке {Объект.ЗагрузкаФичПриОткрытии = "Не загружать"} |
| DisableCheckPossibilityOfSynchronousCalls | Булево |  Отключает проверку возможности использования синхронных вызовов, несмотря на то, что в свойствах конфигурации они явно запрещены. Это нужно, т.к. в тонком клиенте часто возможно использовать синхронные вызовы несмотря на настройки конфигурации. |
| GetStepsCache | Булево | Служебный. Нужен при сборке Vanessa Automation Single. Т.к. Single уже внутри содержит всю библиотеку шагов. И сразу же содержит в себе рассчитанный кеш шагов. |
| DisableFileOptimization | Булево |  Служебный. Отключает механизм оптимизации работы с файлами для серверных баз, когда сервер запущен на том же ПК, что и клиент. Параметр используется для режима самотестирования Vanessa-Automation и использовать его в реальных запусках тестов не рекомендуется. |
| ShowMainForm | Булево |  Параметр включает отображение основной формы Vanessa-Automation, когда фреймворк запущен в пакетном режиме (когда передан параметр StartFeaturePlayer). Иначе в пакетном режиме основная форма отображаться не будет. |
| UseEditor | Булево |  Параметр включает инициализацию редактора при запуске Vanessa Automation из командной строки. По умолчанию редактор не инициализируется при запуске из командной строки для экономии ресурсов. |
| DisableFirstRunHelper | Булево |  Отключает помощник при первом запуске. |


При передаче указанных выше параметров в командной строке порядок параметров не важен.
Таже любой параметр из json можно также передать в командной строке. Можно передвать имя параметра как на русском, так и на английском языке. Если параметр передан и в json и в командной строке, то у значения из командной строки будет преимущество.
Значение и имя параметра разделяется символом равно "=". Параметры типа булево можно записывать не указывая значение, для них значением по умолчанию считается Истина. Если параметр имеет тип массив, например "Список тегов исключение", то значение нужно передавать в виде строки, где значения массива разделены запятыми. Например:

    StartFeaturePlayer;VAParams=C:\Temp\features\VAParams.json;ignoretags=Тег1,Тег2;СписокТеговОтбор=Тег3,Тег4;ДелатьОтчетВФорматеАллюр=Ложь;ОстановкаПриВозникновенииОшибки;КаталогФич=c:\temp
