# Vanessa Automation

[![GitHub release](https://img.shields.io/github/release/Pr-Mex/vanessa-automation.svg)](docs/Changelog.md)
[![Build Status](http://84.237.195.35:32005/buildStatus/icon?job=VAFullCheck)](http://84.237.195.35:32005/job/VAFullCheck/)
[![GitHub Releases](https://img.shields.io/github/downloads/Pr-Mex/vanessa-automation/latest/total?style=flat-square)](https://github.com/Pr-Mex/vanessa-automation/releases)
[![GitHub All Releases](https://img.shields.io/github/downloads/Pr-Mex/vanessa-automation/total?style=flat-square)](https://github.com/Pr-Mex/vanessa-automation/releases)
[![telegram](https://img.shields.io/badge/telegram-chat-green.svg)](https://t.me/testspro1c)

## BDD for 1С:Enterprise

* Текущий релиз в ветке [Master: 1.2.039.1](https://github.com/Pr-Mex/vanessa-automation/tree/master)
* Разработка ведется в ветке [Develop](https://github.com/Pr-Mex/vanessa-automation/tree/develop).
* [Обсудить Ванессу](https://t.me/testspro1c) в телеграм группе, и обсудить всё, что связано с тестированием в 1С.
* [Подписаться на новости о проекте](https://t.me/VanessaAutomation) в телеграм канале.

## Документация

Проект использует принцип формирования автодокументации в формате Markdown и видео:

* [Видео инструкции](https://www.youtube.com/channel/UC114RqHhG__1gET8pzs3AHA/playlists).
* [Вебинар](http://infostart.ru/webinars/537546/). 

## Как стать контрибьютором (предложить свои доработки) проекта?
* Об этом рассказано [в этой статье](https://infostart.ru/public/1092009/)

## Статьи по Vanessa Automation

* [Vanessa-Automation — инструмент тестирования прикладных решений на платформе «1С: Предприятие» @Хабрахабр](https://habr.com/post/418303/)
* [Vanessa-Automation — инструмент автодокументирования прикладных решений на платформе «1С: Предприятие». Кино и BDD. @Хабрахабр](https://habr.com/post/420175/)
* [Как стать контрибьютерром VA](https://infostart.ru/public/1092009/)
* [Vanessa, хочу все и сразу. Новые возможности автоинструкций.](https://infostart.ru/public/1133932/)
* [Vanessa, улучшаем инструкции.](https://infostart.ru/public/1147009/)
* [Vanessa Automation + СППР.](https://infostart.ru/public/1150505/)
* [Суровая практика BDD или: BDDSM-практики, или 50 оттенков желтого.](https://infostart.ru/public/1173711/)
* [Vanessa, видеоинструкции для web-клиента](https://infostart.ru/public/1243801/)
* [Генерация сценариев тестирования внешних печатных форм средствами Vanessa Automation](https://infostart.ru/public/1250707/)
* [Тестирование серверного поведения с Vanessa Automation](https://infostart.ru/1c/articles/1283198/)
* [Практика применения DevOps. Тестирование](https://infostart.ru/1c/articles/1342422/)

## СППР + Vanessa Automation

* [Автоматизация тестирования в СППР 2.0. Часть 1](https://www.youtube.com/watch?v=1UBlV4kWx_o)
* [Автоматизация тестирования в СППР 2.0. Часть 2](https://www.youtube.com/watch?v=gKJmJKIe-nA)

## Видео

* [100+ тестов на Vanessa-Automation. Личный опыт без маркетинга.](https://www.youtube.com/watch?v=_YrmLnM9J1A)
* [Как создать видеоинструкцию в 1С? Пошаговый мастер класс от Виталия Чебана](https://www.youtube.com/watch?v=Jg1sSb-O-F0)
* [Митап 1С:Community от КОРУС Консалтинг. Опыт применения автотестирования](https://www.youtube.com/watch?v=OAT_a25XIXQ)

## Сборка из исходников

В данном репозитории хранятся только исходники.
Вы можете собрать необходимые файлы сами, либо [скачать готовую сборку](https://github.com/Pr-Mex/vanessa-automation/releases).
При первом скачивании репозитория необходимо собрать файлы обработок.

1. Чтобы работала сборка epf надо установить [OneScript](http://oscript.io) версии 1.4.0.177 или выше.
2. Также, чтобы работала сборка и разборка epf надо установить платформу [1С:Предприятие 8.3.17](https://releases.1c.ru).
3. Для запуска сборки epf из исходников надо запустить **Compile.bat**.
4. [Скрипты по сборке/разборке файлов](https://github.com/Pr-Mex/ExternalModulesConverterFor1C).

Чтобы зафиксировать изменения epf файлов, нужно запустить **Decompile.bat**.

## Установка через OneScript
Для обычной сборки

* opm install vanessa-automation

Для сборки VASingle.

* opm install vanessa-automation-single

VASingle отличается от обычной сборки тем, что поставляется в виде одного epf файла, который по функциональности полностью совпадает с основной сборкой.



## Описание простого использования

* пишем feature файлы в формате Gherkin - рекомендуется использовать встренный редактор (VAEditor), созданный на базе VSCode.

```Gherkin

# encoding: utf-8
# language: ru

Функционал: Запуск и получение результатов запуска сценариев
Как любой разработчик продукта
Я хочу иметь возможность запустить проверку сценариев поведения на конфигурации 1С:Предприятие

# Контекст сценария выполняется всегда перед каждым сценарием

Контекст:
Когда существует разрабатываемая мною конфигурация 1С
И существуют требования заказчика к ожидаемому поведения в каталоге ".\features"

# Каждый сценарий состоит из последовательных связанных шагов

Сценарий: Запуск в консольном режиме
Дано Пусть существует файл ".\vb-execute-profile.json"
И в переменную окружения V83PATH установлено значение "C:\Program Files (x86)\1cv8\8.3.6.2151\bin\1cv8.exe"
Когда я запускаю командную строку '%V83PATH% /Execute .\vanessa-automation.epf /C"StartFeaturePlayer;VBParams=.\vb-execute-profile.json'
Тогда появляется файл с результатами '.\BuildStatus.log'
И в каталоге ".\allurereport" существует HTML отчет о результатах проверки сценариев

Сценарий: Запуск в интерактивном режиме
Дано Пусть я открыл обработку "vanessa-automation.epf"
Когда Я нажал кнопку "Загрузить фичи из каталога"
И указал каталог с требованиями заказчика равным ".\features"
И затем нажал кнопку "Сгенерировать шаблоны обработок"
Также в каталоге ".\features" возникли epf файлы идентичные имени feature файла
И при нажатии кнопки "Запустить сценарии" я вижу автоматизированный запуск обработок с признаком "pending" (ожидает реализации)
```

### Классический вариант использования (без интерактивного режима)

Фактически классический вариант использования представляет собой следующий порядок действий:

* зафиксировали требования к информационной системе;
* создали автоматизированные сценарии проверки в виде epf файлов, если не хватает уже готовых;
* наполнили шаги сценариев (сниппеты) кодом проверки поведения;
* запустили сценарии проверки поведения и убедились, что они НЕ работают;
* разработали функционал;
* запустили сценарии проверки поведения;
* убедились что сценарии проверки работают и отчет о проверки показывает "Зелёный" статус.

### Использование в режиме проверки поведения пользовательского интерфейса

Для команд уже имеющих функционал или производящих доработку конфигураций, работающих на управляемых формах, действует упрощенный порядок использования:

* зафиксировали требования к информационной системе;
* разработали управляемые формы или рабочие столы конфигурации в режиме прототипирования;
* запустили запись интерактивных действий пользователя в режиме **менеджера тестирования**;
* дополнили сценарии шагами, проверяющими результат работы (например, проверка движений документа)
* разработали основной функционал;
* запустили сценарии проверки поведения;
* убедились что сценарии проверки работают и отчет о проверки показывает "Зелёный" статус.

## Кто пишет feature файлы ?

Feature файлы могут писать все участники команды:

* менеджер проекта - если обнаружил что заказчику необходимо новое поведение;
* бизнес или системный аналитик - на основе собранных требований и технических заданий;
* ведущий разработки - если обнаружил, что требования недостаточно структурированы;
* архитектор или эксперт 1С - если текущие сценарии некорректно спроектированы с точки зрения метаданных;
* тестировщик - когда пишет сценарии для проверки поведения.

Если вы не уверены в правильности ожидаемого поведения, используйте для этого системы тэгов:

* "@Draft@"  - черновик требования
* "@Предварительно" - начальные заметки

и подобные им обозначения

## Файл профиля запуска обработки

Для запуска в консольном режиме используется понятие *профиль консольного запуска*. Профиль консольного запуска предназначен для удобной передачи параметров. Профиль запуска представляет собой текстовый файл в формате JSON.

Текущие параметры запуска:

* **Каталог фич** - каталог где собраны требования заказчика описанные на языке Gherkin
* **ВыполнитьСценарии** - признак того, что необходимо запустить выполнение сценариев
* **ДелатьОтчетВФорматеАллюр** - признак того, что необходимо формировать HTML отчёт о результатах проверки
* **КаталогOutputAllureБазовый** - адрес каталога для где будет формироваться HTML отчёт
* **ЗавершитьРаботуСистемы** - признак того, что окончанию работы необходимо завершить работу 1С предприятия
* **ВыгружатьСтатусВыполненияСценариевВФайл** - признак, что необходимо формировать файл с финальным статусом проверки
* **ПутьКФайлуДляВыгрузкиСтатусаВыполненияСценариев** - по данному пути будет сформирован файл со статусом проверки (обычно используется на серверах сборки для автоматизированного указания статуса сборки)
* **СписокТеговИсключение** - массив текстовых тэгов, для исключения из проверки (используется например для черновиков сценариев и требований)
* **СписокТеговОтбор** - массив текстовых тэгов для запуска проверки поведения по сценариям, содержащим любой из указанных тэгов
* и другие

[Примеры JSON файлов](https://github.com/Pr-Mex/vanessa-automation/tree/develop/tools/JSON)


Профиль запуска предназначен для простого консольного запуска, пример подобной командной строки выглядит так:

```
%V83PATH% /Execute C:\vanessa-automation\vanessa-automation.epf /TESTMANAGER /C"StartFeaturePlayer;VBParams=C:\VBParams.json"
```

Описание всех параметров командной строки [можно найти тут](https://github.com/Pr-Mex/vanessa-automation/tree/develop/docs/CommandSetting.md)

Описание всех параметров файла VAParams.json [можно найти тут](https://github.com/Pr-Mex/vanessa-automation/blob/develop/docs/JsonParams/JsonParamsRU.md)

## Загрузка глобальных переменных из внешнего файла
Чтобы не зашивать в тесты все плавающие пользовательские переменные, такие как имена баз, строки подключения, логины, пароли и др., имеется возможность вынести эти переменные во внешний файл user_settings.json. Это может быть особенно полезно, когда над фичами работает команда, и у каждого участника существуют свои настройки подключения к базам.
   
Чтобы воспользоваться этой функциональности, нужно выполнить следующее:

 1.  У себя в каталоге с обработкой ванессы создать файл user_settings.json. Сам файл user_settings.json должен отвечать специальному формату:
``` json
{
    "userSettings": [
        {
            "user": "USERNAME_1",
            "settings": {
                "ИМЯ_ПЕРЕМЕННОЙ_1": "ЗНАЧЕНИЕ_ПЕРЕМЕННОЙ_1",
                "ИМЯ_ПЕРЕМЕННОЙ_2": "ЗНАЧЕНИЕ_ПЕРЕМЕННОЙ_2",
            }
        },
        {
            "user": "USERNAME_2",
            "settings": {
                "ИМЯ_ПЕРЕМЕННОЙ_1": "ЗНАЧЕНИЕ_ПЕРЕМЕННОЙ_1",
                "ИМЯ_ПЕРЕМЕННОЙ_2": "ЗНАЧЕНИЕ_ПЕРЕМЕННОЙ_2",
            }
        }
    ]
}
```

2. В свойства user поставить доменное (локальное) имя пользователя, для которого должны применяться настройки. Именно по этому свойству будет определяться, какие пользовательские настройки нужно загружать.

3. В свойстве settings прописать конкретные настройки для каждого пользователя. Состав настроек необязательно должен совпадать между пользователями, для какого-то пользователя настройки могут отсутствовать. 

4. Открыть обработку AD - файл user_settings.json подтянется автоматически из каталога, в котором находится AD (поле каталог инструментов на вкладке Сервис). Если такого файла нет, то загрузка молча игнорируется. Имеется возможность указать свой каталог загрузки настроек, он подчиняется свойству Каталог проекта на вкладке Сервис.
    
Если файл найден, то на основании текущего имени пользователя компьютера или домена (которое определяется через WShell скрипт), ищутся настройки текущего пользователя и загружаются только они. Если настройки не найдены, то выводится предупредительное сообщение.


## Замечания:

* пожелания к использованию можно фиксировать в виде Github Issues;

## Родительский проект

* Проект Vanessa-Automation является продолжением проекта [Vanessa-Behavior 1.1.131](https://github.com/silverbulleters/vanessa-behavior)

## Полезные ссылки:

* [Cucumber](https://cukes.info/)
* [Автоматизированное тестирование 1С](http://v8.1c.ru/overview/Term_000000816.htm)
* [Yandex Allure](http://allure.qatools.ru/)
* [Selenium](http://docs.seleniumhq.org/)
* [Дэн Норт](http://en.wikipedia.org/wiki/Acceptance_test-driven_development)

 

## Лицензии

* основная лицензия продукта - BSD v3
* лицензии стороннего кода - Apache License, GitHub CLA, Freeware, etc

