﻿
///////////////////////////////////////////////////
//Служебные функции и процедуры
///////////////////////////////////////////////////

&НаКлиенте
// контекст фреймворка Vanessa-Automation
Перем Ванесса;
 
&НаКлиенте
// Структура, в которой хранится состояние сценария между выполнением шагов. Очищается перед выполнением каждого сценария.
Перем Контекст Экспорт;
 
&НаКлиенте
// Структура, в которой можно хранить служебные данные между запусками сценариев. Существует, пока открыта форма Vanessa-Automation.
Перем КонтекстСохраняемый Экспорт;

// Делает отключение модуля
&НаКлиенте
Функция ОтключениеМодуля() Экспорт

	Ванесса = Неопределено;
	Контекст = Неопределено;
	КонтекстСохраняемый = Неопределено;

КонецФункции

&НаКлиенте
// Функция экспортирует список шагов, которые реализованы в данной внешней обработке.
Функция ПолучитьСписокТестов(КонтекстФреймворкаBDD) Экспорт
	Ванесса = КонтекстФреймворкаBDD;
	
	ВсеТесты = Новый Массив;

	//описание параметров
	//Ванесса.ДобавитьШагВМассивТестов(ВсеТесты,Снипет,ИмяПроцедуры,ПредставлениеТеста,ОписаниеШага,ТипШага,Транзакция,Параметр);

	Ванесса.ДобавитьШагВМассивТестов(ВсеТесты,"ЯЗапоминаюЗначениеПоляСИменемВБуферОбмена(Парам01)","ЯЗапоминаюЗначениеПоляСИменемВБуферОбмена","И я запоминаю значение поля с именем ""ИмяПоля"" в буфер обмена","Помещает значение, типа текст или двоичные данные, указанного поля в буфер обмена", "Прочее.Буфер обмена");
	Ванесса.ДобавитьШагВМассивТестов(ВсеТесты,"ЯВставляюТекстовоеЗначениеБуфераОбменаВПолеСИменем(Парам01)","ЯВставляюТекстовоеЗначениеБуфераОбменаВПолеСИменем(Парам01)","И я вставляю текстовое значение буфера обмена в поле с именем """" ","Помещает текстовое значение буфера обмена в указанное поле", "Прочее.Буфер обмена");

	Возврат ВсеТесты;
КонецФункции
	
&НаСервере
// Служебная функция.
Функция ПолучитьМакетСервер(ИмяМакета)
	ОбъектСервер = РеквизитФормыВЗначение("Объект");
	Возврат ОбъектСервер.ПолучитьМакет(ИмяМакета);
КонецФункции
	
&НаКлиенте
// Служебная функция для подключения библиотеки создания fixtures.
Функция ПолучитьМакетОбработки(ИмяМакета) Экспорт
	Возврат ПолучитьМакетСервер(ИмяМакета);
КонецФункции



///////////////////////////////////////////////////
//Работа со сценариями
///////////////////////////////////////////////////

&НаКлиенте
// Функция выполняется перед началом каждого сценария
Функция ПередНачаломСценария() Экспорт
	
КонецФункции

&НаКлиенте
// Функция выполняется перед окончанием каждого сценария
Функция ПередОкончаниемСценария() Экспорт
	
КонецФункции



///////////////////////////////////////////////////
//Реализация шагов
///////////////////////////////////////////////////

&НаКлиенте
//И я запоминаю значение поля с именем """" в буфер обмена
//@ЯЗапоминаюЗначениеПоляСИменемВБуферОбмена(Парам01)
Функция ЯЗапоминаюЗначениеПоляСИменемВБуферОбмена(Парам01) Экспорт
	
	Значение = Ванесса.ПолучитьЗначениеРеквизитаОткрытойФормыПоЗаголовку(Парам01);
	Ванесса.ПоместитьВБуферОбменаVA(Значение);
	
КонецФункции

&НаКлиенте
//И я вставляю текстовое значение буфера обмена в поле с именем ""Номер""
//@ЯВставляюТекстовоеЗначениеБуфераОбменаВПолеСИменем(Парам01)
Функция ЯВставляюТекстовоеЗначениеБуфераОбменаВПолеСИменем(Парам01) Экспорт
	
	Текст = Ванесса.БуферОбменаVA.Текст;
	ПолеРеквизит = Ванесса.НайтиРеквизитОткрытойФормыПоЗаголовку(Парам01, Истина, Истина, Тип("ТестируемоеПолеФормы"));
	Ванесса.ВвестиВПолеТекст(ПолеРеквизит, Текст);
	
КонецФункции

