﻿
#Область Служебные_функции_и_процедуры

&НаКлиенте
// контекст фреймворка Vanessa-Automation
Перем Ванесса;
 
&НаКлиенте
// Структура, в которой хранится состояние сценария между выполнением шагов. Очищается перед выполнением каждого сценария.
Перем Контекст Экспорт;
 
&НаКлиенте
// Структура, в которой можно хранить служебные данные между запусками сценариев. Существует, пока открыта форма Vanessa-Automation.
Перем КонтекстСохраняемый Экспорт;

&НаКлиенте
// Функция экспортирует список шагов, которые реализованы в данной внешней обработке.
Функция ПолучитьСписокТестов(КонтекстФреймворкаBDD) Экспорт
	Ванесса = КонтекстФреймворкаBDD;
	
	ВсеТесты = Новый Массив;

	//описание параметров
	//Ванесса.ДобавитьШагВМассивТестов(ВсеТесты,Снипет,ИмяПроцедуры,ПредставлениеТеста,ОписаниеШага,ТипШага,Транзакция,Параметр);

	Ванесса.ДобавитьШагВМассивТестов(ВсеТесты,"ЯУстанавливаюНазваниеФичи(Парам01)","ЯУстанавливаюНазваниеФичи","И Я устанавливаю название фичи 'Моя дивная чудная галактика'","","");
	Ванесса.ДобавитьШагВМассивТестов(ВсеТесты,"ЯУстанавливаюНазваниеЭпика(Парам01)","ЯУстанавливаюНазваниеЭпика","Когда Я устанавливаю название эпика 'Моя дивная чудная вселенная'","","");
	Ванесса.ДобавитьШагВМассивТестов(ВсеТесты,"ЯУстанавливаюНазваниеИстории(Парам01)","ЯУстанавливаюНазваниеИстории","И Я устанавливаю название истории 'Мой дивный чудный мир'","","");

	Возврат ВсеТесты;
КонецФункции
	
// Делает отключение модуля
Процедура ОтключениеМодуля() Экспорт
	
	Ванесса = Неопределено;
	Контекст = Неопределено;
	КонтекстСохраняемый = Неопределено;
	
КонецПроцедуры
	
&НаСервере
// Служебная функция.
Функция ПолучитьМакетСервер(ИмяМакета)
	ОбъектСервер = РеквизитФормыВЗначение("Объект");
	Возврат ОбъектСервер.ПолучитьМакет(ИмяМакета);
КонецФункции
	
&НаКлиенте
// Служебная функция для подключения библиотеки создания fixtures.
Функция ПолучитьМакетОбработки(ИмяМакета) Экспорт
	Возврат ПолучитьМакетСервер(ИмяМакета);
КонецФункции

#КонецОбласти



#Область Работа_со_сценариями

&НаКлиенте
// Функция выполняется перед началом каждого сценария
Функция ПередНачаломСценария() Экспорт
	
КонецФункции

&НаКлиенте
// Функция выполняется перед окончанием каждого сценария
Функция ПередОкончаниемСценария() Экспорт
	
КонецФункции

#КонецОбласти


///////////////////////////////////////////////////
//Реализация шагов
///////////////////////////////////////////////////

&НаКлиенте
//И Я устанавливаю название фичи 'Моя дивная чудная галактика'
//@ЯУстанавливаюНазваниеФичи(Парам01)
Функция ЯУстанавливаюНазваниеФичи(Парам01) Экспорт
		ЯУстанавливаюМеткеЗначение("epic", Парам01);
	//Ванесса.ПосмотретьЗначение(Парам01,Истина);
	//ВызватьИсключение "Не реализовано.";
КонецФункции

&НаКлиенте
//Когда Я устанавливаю название эпика 'Моя дивная чудная вселенная'
//@ЯУстанавливаюНазваниеЭпика(Парам01)
Функция ЯУстанавливаюНазваниеЭпика(Парам01) Экспорт
	ЯУстанавливаюМеткеЗначение("story", Парам01);
	//ВызватьИсключение "Не реализовано.";
КонецФункции

&НаКлиенте
//И Я устанавливаю название истории 'Мой дивный чудный мир'
//@ЯУстанавливаюНазваниеИстории(Парам01)
Функция ЯУстанавливаюНазваниеИстории(Парам01) Экспорт
	ЯУстанавливаюМеткеЗначение("feature", Парам01);

	//ВызватьИсключение "Не реализовано.";
КонецФункции


&НаКлиенте
Процедура ЯУстанавливаюМеткеЗначение(Метка, Значение) 
	СостояниеVanessaBehvior = Ванесса.ПолучитьСостояниеVanessaBehavior();
	
	РезультатПрохожденияТестовВСценарии = СостояниеVanessaBehvior["ТекущийСценарий"].РезультатПрохожденияТестовСценария;
	Если НЕ РезультатПрохожденияТестовВСценарии.Свойство("СписокМеток") Тогда
		РезультатПрохожденияТестовВСценарии.Вставить("СписокМеток", Новый СписокЗначений);
	КонецЕсли;
	
	РезультатПрохожденияТестовВСценарии["СписокМеток"].Добавить(Метка, Значение);
	
КонецПроцедуры


